import com.sybase.apachetest.*;

import javax.xml.rpc.Stub;
import java.net.URL;
import java.security.Security;

public class ASEExecute
{
    public static void main(String[] args) 
    {
        try 
        {
            if (args.length < 8)
            {
                System.out.println ("Gotta have 8 args only got: " + args.length + "\n");
                System.out.println ("Argument 1: Endpoint for SOAP ");
                System.out.println ("Argument 2: ASE Service Name ");
                System.out.println ("Argument 3: ASE Username to login as ");
                System.out.println ("Arugment 4: ASE Password to use in login ");
		System.out.println ("Argument 5: SQL X Options ");
		System.out.println ("Argument 6: Dataoutput (one of all, schema, dtd or data or count)");
                System.out.println ("Arugment 7: Number of times to execute (in session) ");
                System.out.println ("Arugment 8: SQL to execute ");

                System.exit (1);
            }

            String endpoint = args[0];
            System.setProperty ("java.protocol.handler.pkgs", "com.sun.net.ssl.internal.www.protocol");
	    Security.addProvider (new com.sun.net.ssl.internal.ssl.Provider());

            URL endURL = new URL (endpoint);
            String serverName = args[1];

            String userName = args[2];
            String password = args [3];

            if (password.compareTo("nopasswordspecified") == 0)
            {
            	System.out.println ("Replacing password with null token.");
            	password = "";
            }
            String sqlxOptions = args[4];
            String dataOutput = args[5];
            String numExecutionStr = args[6];
            int numExecution = 1;
            try
            {
		Integer tmp = new Integer (numExecutionStr);
	        numExecution = tmp.intValue ();
            }
            catch (NumberFormatException err)
            {
                System.out.println ("Could not convert " + numExecutionStr + " to a number.");
                System.out.println ("Assuming 1 execution.");
                numExecution = 1;
            }

            String sql = args[7];

            System.out.println ("SOAP Endpoint: " + endpoint);
            System.out.println ("ASE Service Name: " + serverName);
            System.out.println ("ASE Username: " + userName);
            System.out.println ("ASE Password: ********** "  );
            System.out.println ("SQL X options: " + sqlxOptions);
            System.out.println ("Data Output: " + dataOutput);
            System.out.println ("Number of executions: " + numExecution);
            System.out.println ("Sql Select to execute: " + sql);
            
            ExecuteStoredProcServiceLocator service = new ExecuteStoredProcServiceLocator ();

            if (numExecution != 1)
            {
                service.setMaintainSession (true);
            }
            ExecuteStoredProc port = service.getase(endURL);

		for (int ii = 0; ii < numExecution; ii++)
		{
	            DataReturn[] data = port.execute (serverName,  
	                                                 userName, 
	                                                 password,
							 sqlxOptions,
	                                                 sql);
	
	            if (data != null)
	            {
			for (int jj = 0; jj < data.length; jj++)
			{
			    	    System.out.println ("Printing result set #" + jj );
				    if (dataOutput.compareTo ("all") == 0
					|| dataOutput.compareTo ("dtd") == 0)
				    {
			        	System.out.println ("data.getDTD is: \n" + data[jj].getDTD ());
				    }
		
				    if (dataOutput.compareTo ("all") == 0
				        || dataOutput.compareTo ("data") == 0)
				    {
						System.out.println ("data.getXML is: \n" + data[jj].getXML ());
		            	    }
		
				    if (dataOutput.compareTo ("all") == 0
				        || dataOutput.compareTo ("schema") == 0)
		 		    {
		            	        System.out.println ("data.getSchema is: \n" + data[jj].getSchema ());
				    }
		            	    System.out.println ("data.updateCount is: " + data[jj].getUpdateCount ());
				}
			}
		    }
        } 
        catch (Exception ex) 
        {
            ex.printStackTrace();
        }
    }    
}
