@echo off

echo. 
<nul (set/p anyvariable=%0 initiating execution at & time /t)
echo. 

REM
REM   We may have %SYBASE% and %SYBASE_JRE6% set, and if so, we use them.
REM   Othewise we use hard coded defaults and notify the user of what
REM   we are doing.
REM

if [%SYBASE_JRE6%]==[] ( 
    set JRE=C:\jdk1.3.1_08\jre
    echo Environment Variable SYBASE_JRE6 is not set. Using %JRE%
) else (
    set JRE=%SYBASE_JRE6%
)
set JAVA=%JRE%\bin\java

set WS_BASE=C:\install\WS-15_0
if [%SYBASE%]==[] ( 
    set SYBASE_WS=%WS_BASE%
    echo Environment Variable SYBASE is not set. Using %SYBASE_WS% as web services base.
) else (
    set SYBASE_WS=%SYBASE%\WS-15_0
)

set SYBASE_WS_LIB=%SYBASE_WS%\lib

REM
REM  Set up a custom classpath to include all Axis libraries and our compiled
REM  example code.
REM

set MYPATH=%SYBASE_WS_LIB%\axis.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\jaxrpc.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\saaj.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\commons-logging.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\commons-discovery.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\log4j-1.2.4.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\wsdl4j.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\jcert.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\jnet.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\jsse.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\xercesImpl.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\xmlParserAPIs.jar
set MYPATH=%MYPATH%;%SYBASE_WS_LIB%\tools.jar
set MYPATH=%MYPATH%;%SYBASE_WS%\samples\apacheclient\classes
set MYPATH=%MYPATH%;%SYBASE_WS%\samples\apacheclient\apacheclient.jar

set JAVAC=%JAVA% -classpath %MYPATH% com.sun.tools.javac.Main

REM
REM  Compile the code
REM

%JAVAC% -classpath %MYPATH% -d %SYBASE_WS%\samples\apacheclient\classes ASEExecute.java 


