@echo off

echo. 
<nul (set/p anyvariable=%0 initiating execution at & time /t)
echo. 

REM
REM   We may have %SYBASE% and %SYBASE_JRE6% set, and if so, we use them.
REM   Othewise we use hard coded defaults and notify the user of what
REM   we are doing.
REM

if [%SYBASE_JRE6%]==[] ( 
    set JRE=C:\jdk1.3.1_08\jre
    echo Environment Variable SYBASE_JRE6 is not set. Using %JRE%
) else (
    set JRE=%SYBASE_JRE6%
)
set JAVA=%JRE%\bin\java

set WS_BASE=C:\install\WS-15_0
if [%SYBASE%]==[] ( 
    set SYBASE_WS=WS_15_0
    echo Environment Variable SYBASE is not set. Using %SYBASE_WS% as web services base.
) else (
    set SYBASE_WS=WS-15_0
)

set SAMPLE_LIB=%SYBASE%\%SYBASE_WS%\samples\apacheclient\lib

REM
REM  Set up a custom classpath to include all Axis libraries and our compiled
REM  example code.
REM

set MYPATH=%SAMPLE_LIB%\axis.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\jaxrpc.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\saaj.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\commons-logging.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\commons-discovery.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\log4j-1.2.4.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\wsdl4j.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\jcert.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\jnet.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\jsse.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\xercesImpl.jar
set MYPATH=%MYPATH%;%SAMPLE_LIB%\xmlParserAPIs.jar
set MYPATH=%MYPATH%;%SYBASE%\%SYBASE_WS%\samples\apacheclient\classes
set MYPATH=%MYPATH%;%SYBASE%\%SYBASE_WS%\samples\apacheclient\apacheclient.jar

set JAVA_DEFINES=-Djavax.net.ssl.trustStore=%SYBASE%\%SYBASE_WS%/producer/keystore

REM
REM  Run the example.
REM

%JAVA% -classpath %MYPATH% %JAVA_DEFINES% ASEExecute %1 %2 %3 %4 %5 %6 %7 %8 %9

